#
/*
 *    Copyright (C) 2010 .. 2024
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    Lazy Chair Computing
 *
 *    This file is part of Qt-DAB
 *
 *    Qt-DAB is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    Qt-DAB is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Qt-DAB; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once

#include	<QObject>
#include	"qwt-2.h"
#include        <qwt_plot_spectrogram.h>
#include        "spectrogramdata.h"
#include	<cstdint>
#include        "dab-constants.h"

class	QwtLinearColorMap;
class	QwtScaleWidget;

class waterfallScope: public QObject, public QwtPlotSpectrogram {
Q_OBJECT
public:
		waterfallScope	(QwtPlot *, int, int);
		~waterfallScope	();
	void	display		(const floatQwt *, const floatQwt *,
	                         floatQwt, int32_t);
	void	cleanUp		();
private:
	QwtPlot		*plotgrid;
	int		displaySize;
	int		bitDepth;
	spectrogramData	*WaterfallData;
	int16_t		rasterSize;
	double		*plotData;
	QwtLinearColorMap	*colorMap;
	QwtScaleWidget		*rightAxis;
};

